// swad.js: javascript functions

/*
    SWAD ("Sistema Web de Apoyo a la Docencia" in Spanish,
    "Web System for Teaching Support" in English),
    is a web platform developed at the University of Granada (Spain),
    and used to support university teaching.
    Copyright (C) 1999-2010 Antonio Caas-Vargas
    & Daniel J. Calandria-Hernndez,
    University of Granada (SPAIN) (acanas@ugr.es)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

// Write a clock updated every minute
// Hour and Minute are global variables initialized before call this function
function writeClock(){
	var StrHour = Hour;
	var StrMinute = Minute;
	if (Hour < 10)
		StrHour = "0" + StrHour;
	if (Minute < 10)
		StrMinute = "0" + StrMinute;
	if (++Minute == 60) {
		Minute = 0;
		if (++Hour == 24)
			Hour = 0;	
	}
	var RelojImprimible = StrHour + ":" + StrMinute + " h";
	document.getElementById('hm').innerHTML = RelojImprimible;
	setTimeout("writeClock()",60000);
}

// Automatic refresh of connected users using AJAX. This function must be called from time to time
var objXMLHttpReq = false;

function refreshConnected() {
	objXMLHttpReq = AJAXCreateObject();
	if (objXMLHttpReq) {
      		var RefreshParams = RefreshParam1 + '&' + RefreshParam2 + '&' + RefreshParam3;
		objXMLHttpReq.onreadystatechange = readConnUsrsData;	// onreadystatechange must be lowercase
		objXMLHttpReq.open('POST','swad', true);
		objXMLHttpReq.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
		objXMLHttpReq.send(RefreshParams);
	}
}

// Create AJAX object	(try is unknown in earlier versions of Netscape, but works in IE5)
function AJAXCreateObject() {
	var obj = false;
	if (window.XMLHttpRequest) {	// Mozilla, Safari,...
		obj = new XMLHttpRequest();
	} else if (window.ActiveXObject) {	// IE
		try {
			obj = new ActiveXObject("Msxml2.XMLHTTP");
		} catch (e) {
			try {
				obj = new ActiveXObject("Microsoft.XMLHTTP");
			} catch (e) {}
		}
	}
	return obj;
}

// Receives and show connected users data
function readConnUsrsData() {
	if (objXMLHttpReq.readyState == 4) {	// Check if data have been received
		if (objXMLHttpReq.status == 200) {
			var separator1 = objXMLHttpReq.responseText.indexOf('|',0);		// Get separator position
			var delay = objXMLHttpReq.responseText.substring(0,separator1);		// Get refresh delay
			var htmlCode = objXMLHttpReq.responseText.substring(separator1+1);	// Get HTML code
			var separator2 = htmlCode.indexOf('|',0);				// Get separator position
			var htmlMsg = htmlCode.substring(0,separator2);				// Get HTML code for new messages
			var htmlCon = htmlCode.substring(separator2+1);				// Get HTML code for connected
			var separator3 = htmlCon.indexOf('|',0);				// Get separator position
			var htmlGblCon = htmlCon.substring(0,separator3);			// Get HTML code for new messages
			var htmlCrsCon = htmlCon.substring(separator3+1);			// Get HTML code for connected
			if (htmlMsg.length) {
				var divNewMsgs = document.getElementById('msg');		// Access to new messages DIV
				if (divNewMsgs)
					divNewMsgs.innerHTML = htmlMsg;				// Update new messages DIV
			}
			var divGblConnected = document.getElementById('globalconnected');	// Access to global connected DIV
			if (divGblConnected)
				divGblConnected.innerHTML = htmlGblCon;				// Update global connected DIV
			if (htmlCrsCon.length) {
				var divCrsConnected = document.getElementById('courseconnected');	// Access to course connected DIV
				if (divCrsConnected)
					divCrsConnected.innerHTML = htmlCrsCon;				// Update course connected DIV
			}
			setTimeout("refreshConnected()",delay);
		}
	}
}

// Zoom a user's photograph
function zoom(imagen,urlFoto,shortName) {
	var xPos = imagen.offsetLeft;
	var yPos = imagen.offsetTop;
	var tempEl = imagen.offsetParent;
	while (tempEl != null) {
		xPos += tempEl.offsetLeft;
		yPos += tempEl.offsetTop;
		tempEl = tempEl.offsetParent;
	}
        xPos -= (150+12);
        yPos -= ((200+12)/2);
        if (yPos < 0)
           yPos = 0;
	document.getElementById('zoomLyr').style.left = xPos + 'px';
	document.getElementById('zoomLyr').style.top = yPos + 'px';
	document.getElementById('zoomImg').src = urlFoto;
	document.getElementById('zoomTxt').innerHTML = '<FONT class="ZOOM_TXT">' + shortName + '</FONT>';
}

// Exit from zooming a user's photograph
function noZoom(imagen) {
	var xPos = -(150+12);
	var yPos = -(200+12+88);
	document.getElementById('zoomTxt').innerHTML = '';
	document.getElementById('zoomImg').src='/icon/_.gif';
	document.getElementById('zoomLyr').style.left = xPos + 'px';
	document.getElementById('zoomLyr').style.top = yPos + 'px';
}

// Select or unselect a radio element in a form
function selectUnselectRadio (radio,groupRadios,numRadiosInGroup){
	if (radio.IsChecked) radio.checked = false;
	radio.IsChecked = !radio.IsChecked;
	for (var i=0; i<numRadiosInGroup; i++)
		if (groupRadios[i] != radio) groupRadios[i].IsChecked = 0;
}

// Activate a parent checkbox when all children checkboxes are activated
// Deactivate a parent checkbox when any child checkbox is deactivated
function checkParent(CheckBox, MainCheckbox) {
	var IsChecked = true, i, Formul = CheckBox.form;
	for (i=0; i<Formul.elements.length; i++)
		if (Formul.elements[i].name == CheckBox.name)
			if (!(Formul.elements[i].checked)) { IsChecked = false; break; }
	Formul[MainCheckbox].checked = IsChecked;
}
// Activate all children checkboxes when parent checkbox is activated
// Deactivate all children checkboxes when parent checkbox is deactivated
function togglecheckChildren(MainCheckbox, GroupCheckboxes) {
	var i, Formul = MainCheckbox.form;
	for (i=0; i<Formul.elements.length; i++)
		if (Formul.elements[i].name == GroupCheckboxes) Formul.elements[i].checked = MainCheckbox.checked;
}

// Deactivate a parent checkbox when any child checkbox is activated
// Activate a parent checkbox when all children checkboxes are deactivated
function uncheckParent(CheckBox, MainCheckbox) {
	var IsChecked = false, i, Formul = CheckBox.form;
	for (i=0; i<Formul.elements.length; i++)
		if (Formul.elements[i].name == CheckBox.name)
			if (Formul.elements[i].checked) { IsChecked = true; break; }
	Formul[MainCheckbox].checked = !IsChecked;
}
// Deactivate all children checkboxes when parent checkbox is activated
function uncheckChildren(MainCheckbox, GroupCheckboxes) {
	var i, Formul = MainCheckbox.form;
        if (MainCheckbox.checked)
		for (i=0; i<Formul.elements.length; i++)
			if (Formul.elements[i].name == GroupCheckboxes) Formul.elements[i].checked = false;
}

// Adjust a date form correcting days in the month
function adjustDateForm (DayForm,MonthForm,YearForm) {
	var Days = 31;
	var Year = YearForm.options[YearForm.selectedIndex].value;
	if (MonthForm.options[2].selected)			// Adjust days of february
		{ if ((((Year % 4) == 0) && ((Year % 100) != 0)) || ((Year % 400) == 0)) Days = 29; else Days = 28; }
	else if (MonthForm.options[4].selected || MonthForm.options[6].selected || MonthForm.options[9].selected || MonthForm.options[11].selected) Days = 30;
	if (DayForm.selectedIndex > Days) DayForm.options[Days].selected = true;
	for (var i=DayForm.options.length; i<=Days ; i++)	// Create new days at start
		{ var x = String (i); DayForm.options[i] = new Option(x,x); }
	for (var i=DayForm.options.length-1; i>Days; i--)	// Remove days at the end
		DayForm.options[i] = null;
}

// Set a the date in a date form to a specified date  
function setDateTo (elem,Day,Month,Year) {
	document.getElementById('StartYear').options[Year].selected = true;
	document.getElementById('StartMonth').options[Month].selected = true;
	adjustDateForm (elem.form.StartDay,elem.form.StartMonth,elem.form.StartYear)
	document.getElementById('StartDay').options[Day].selected = true;
	document.getElementById('EndYear').options[Year].selected = true;
	document.getElementById('EndMonth').options[Month].selected = true;
	adjustDateForm (elem.form.EndDay,elem.form.EndMonth,elem.form.EndYear)
	document.getElementById('EndDay').options[Day].selected = true;
}

// Adjust iFrame height to height of browser
function iFrameHeight () {
	var h;
	if (document.getElementById) {
		if (self.innerHeight) // all except Explorer
			h = self.innerHeight;
		else if (document.documentElement && document.documentElement.clientHeight)
			// Explorer 6 Strict Mode
			h = document.documentElement.clientHeight;
		else if (document.body) // other Explorers
			h = document.body.clientHeight;
		if (h == 0) h = 480;
		else {
			h = h - 210;
			if (h < 200) h = 200;
		}
		document.getElementById('iframe_central').style.height = h;
	}
}

// Change text of a test descriptor
function changeTxtTag(NumTag){
	var Sel = document.getElementById('SelDesc'+NumTag);
	document.getElementById('TagTxt'+NumTag).value = Sel.options[Sel.selectedIndex].value;
}

// Change selectors of test descriptors
function changeSelTag(NumTag){
	var Sel = document.getElementById('SelDesc'+NumTag);
	var Txt = document.getElementById('TagTxt'+NumTag);
	for (var i=0; i<Sel.options.length-1 ; i++)
		if (Sel.options[i].value.toUpperCase() == Txt.value.toUpperCase()){
			Sel.options[i].selected = true;
			Txt.value = Sel.options[i].value;
			break;
		}
	if (i == Sel.options.length-1) // End reached without matching
		Sel.options[i].selected = true;
}

// Activate or deactivate answer types of a test question
function enableDisableAns(Formul) {
	var Tst_ANS_TRUE_FALSE	= 0;
	var Tst_ANS_UNIQUE_CHOICE	= 1;
	var Tst_ANS_MULTIPLE_CHOICE	= 2;
	var Tst_ANS_TEXT		= 3;
	var Tst_ANS_INT		= 4;
	var Tst_ANS_FLOAT		= 5;
	if (Formul.AnswerType[Tst_ANS_TRUE_FALSE].checked){
		for (var i=0; i<Formul.elements.length; i++)
			if (Formul.elements[i].name == 'AnsTF') Formul.elements[i].disabled = false;
			else if (Formul.elements[i].name == 'AnsUni' || Formul.elements[i].name == 'AnsMulti' || Formul.elements[i].name == 'AnsInt' || Formul.elements[i].name == 'AnsFloatMin' || Formul.elements[i].name == 'AnsFloatMax' || Formul.elements[i].name == 'Shuffle') Formul.elements[i].disabled = true;
			else enableDisableContAns(Formul.elements[i],true);
	}
	else if (Formul.AnswerType[Tst_ANS_UNIQUE_CHOICE].checked){
		for (var i=0; i<Formul.elements.length; i++)
			if (Formul.elements[i].name == 'AnsUni' || Formul.elements[i].name == 'Shuffle') Formul.elements[i].disabled = false;
			else if (Formul.elements[i].name == 'AnsTF' || Formul.elements[i].name == 'AnsMulti' || Formul.elements[i].name == 'AnsInt' || Formul.elements[i].name == 'AnsFloatMin' || Formul.elements[i].name == 'AnsFloatMax') Formul.elements[i].disabled = true;
			else enableDisableContAns(Formul.elements[i],false);
	}
	else if (Formul.AnswerType[Tst_ANS_MULTIPLE_CHOICE].checked){
		for (var i=0; i<Formul.elements.length; i++)
			if (Formul.elements[i].name == 'AnsMulti' || Formul.elements[i].name == 'Shuffle') Formul.elements[i].disabled = false;
			else if (Formul.elements[i].name == 'AnsTF' || Formul.elements[i].name == 'AnsUni' || Formul.elements[i].name == 'AnsInt' || Formul.elements[i].name == 'AnsFloatMin' || Formul.elements[i].name == 'AnsFloatMax') Formul.elements[i].disabled = true;
			else enableDisableContAns(Formul.elements[i],false);
	}
	else if (Formul.AnswerType[Tst_ANS_TEXT].checked){
		for (var i=0; i<Formul.elements.length; i++)
			if (Formul.elements[i].name == 'AnsTF' || Formul.elements[i].name == 'AnsUni' || Formul.elements[i].name == 'AnsMulti' || Formul.elements[i].name == 'AnsInt' || Formul.elements[i].name == 'AnsFloatMin' || Formul.elements[i].name == 'AnsFloatMax') Formul.elements[i].disabled = true;
			else enableDisableContAns(Formul.elements[i],false);
	}
	else if (Formul.AnswerType[Tst_ANS_INT].checked){
		for (var i=0; i<Formul.elements.length; i++)
			if (Formul.elements[i].name == 'AnsInt') Formul.elements[i].disabled = false;
			else if (Formul.elements[i].name == 'AnsTF' || Formul.elements[i].name == 'AnsUni' || Formul.elements[i].name == 'AnsMulti' || Formul.elements[i].name == 'AnsFloatMin' || Formul.elements[i].name == 'AnsFloatMax' || Formul.elements[i].name == 'Shuffle') Formul.elements[i].disabled = true;
			else enableDisableContAns(Formul.elements[i],true);
	}
	else if (Formul.AnswerType[Tst_ANS_FLOAT].checked){
		for (var i=0; i<Formul.elements.length; i++)
			if (Formul.elements[i].name == 'AnsFloatMin' || Formul.elements[i].name == 'AnsFloatMax') Formul.elements[i].disabled = false;
			else if (Formul.elements[i].name == 'AnsTF' || Formul.elements[i].name == 'AnsUni' || Formul.elements[i].name == 'AnsMulti' || Formul.elements[i].name == 'AnsInt' || Formul.elements[i].name == 'Shuffle') Formul.elements[i].disabled = true;
			else enableDisableContAns(Formul.elements[i],true);
	}
}

// Activate or deactivate response contents of a test question
function enableDisableContAns(Elem,IsDisabled) {
	var Tst_MAX_ANSWERS_PER_QUESTION = 10;
	for (var i=0; i<Tst_MAX_ANSWERS_PER_QUESTION; i++)
		if (Elem.name == ('AnsStr'+i))
			Elem.disabled = IsDisabled;
}

// Selection of statistics of current course ****/
function enableRowsPage () {
	document.getElementById('CountType').disabled = true;
	document.getElementById('RowsPage').disabled = false;
}
function disableRowsPage () {
	document.getElementById('CountType').disabled = false;
	document.getElementById('RowsPage').disabled = true;
}
