// swad_act.h: actions

#ifndef _SWAD_ACT
#define _SWAD_ACT
/*
    SWAD ("Sistema Web de Apoyo a la Docencia" in Spanish,
    "Web System for Teaching Support" in English),
    is a web platform developed at the University of Granada (Spain),
    and used to support university teaching.
    Copyright (C) 1999-2010 Antonio Caas-Vargas
    & Daniel J. Calandria-Hernndez,
    University of Granada (SPAIN) (acanas@ugr.es)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/****************************************************************************/
/********************************* Headers **********************************/
/****************************************************************************/

#include "swad_boo.h"
#include "swad_txt.h"

/****************************************************************************/
/***************************** Public constants *****************************/
/****************************************************************************/

// Related with tabs and actions
typedef enum
  {
   TabUnk = 0,
   TabDeg = 1,
   TabCrs = 2,
   TabAss = 3,
   TabUsr = 4,
   TabMsg = 5,
   TabSta = 6,
   TabPer = 7,
   TabPlg = 8,
  } Act_Tab_t;
typedef enum
  {
   Act_MAIN_WINDOW,
   Act_NEW_WINDOW,
   Act_CHAT_WINDOW
  } Act_BrowserWindow_t;
typedef int Act_Action_t;

/* Related with tabs, menus, etc. */
#define Act_NUM_TABS	9
#define Act_NUM_ACTIONS	(10+82+133+127+68+155+11+40+9)

#define Act_MAX_OPTIONS_IN_MENU_PER_TAB 20

/****************************************************************************/
/************************ Not asociates with tabs ***************************/
/****************************************************************************/
#define ActAll		 0
#define ActUnk		 1
#define ActAutUsrInt	 2
#define ActAutUsrExt	 3
#define ActChgUsrTypLog  4
#define ActMnu		 5
#define ActDirAcc	 6
#define ActRef		 7
#define ActWebSvc	 8
#define ActLogOut	 9
/****************************************************************************/
/******************************* Degree tab *********************************/
/****************************************************************************/
// Actions in menu
#define ActReqSch		(ActLogOut+ 1)
#define ActSeeIns		(ActLogOut+ 2)
#define ActSeeCtr		(ActLogOut+ 3)
#define ActSeeDpt		(ActLogOut+ 4)
#define ActSeePlc		(ActLogOut+ 5)
#define ActSeeHld		(ActLogOut+ 6)
#define ActLstAdm		(ActLogOut+ 7)
#define ActReqNewAdm		(ActLogOut+ 8)
#define ActReqRemAdm		(ActLogOut+ 9)
#define ActReqEdiDegTyp		(ActLogOut+10)
#define ActReqEdiDeg		(ActLogOut+11)
#define ActReqEdiCrs		(ActLogOut+12)
#define ActSeeLnk		(ActLogOut+13)
#define ActSetUp		(ActLogOut+14)
// Secondary actions
#define ActSchCrs		(ActLogOut+15)
#define ActSchCrsTch		(ActLogOut+16)
#define ActEdiIns		(ActLogOut+17)
#define ActNewIns		(ActLogOut+18)
#define ActRemIns		(ActLogOut+19)
#define ActRenInsSho		(ActLogOut+20)
#define ActRenInsFul		(ActLogOut+21)
#define ActChgInsLog		(ActLogOut+22)
#define ActChgInsWWW		(ActLogOut+23)
#define ActEdiCtr		(ActLogOut+24)
#define ActNewCtr		(ActLogOut+25)
#define ActRemCtr		(ActLogOut+26)
#define ActChgCtrIns		(ActLogOut+27)
#define ActRenCtrSho		(ActLogOut+28)
#define ActRenCtrFul		(ActLogOut+29)
#define ActChgCtrWWW		(ActLogOut+30)
#define ActEdiDpt		(ActLogOut+31)
#define ActNewDpt		(ActLogOut+32)
#define ActRemDpt		(ActLogOut+33)
#define ActChgDptIns		(ActLogOut+34)
#define ActRenDptSho		(ActLogOut+35)
#define ActRenDptFul		(ActLogOut+36)
#define ActChgDptWWW		(ActLogOut+37)
#define ActEdiPlc		(ActLogOut+38)
#define ActNewPlc		(ActLogOut+39)
#define ActRemPlc		(ActLogOut+40)
#define ActRenPlcSho		(ActLogOut+41)
#define ActRenPlcFul		(ActLogOut+42)
#define ActEdiHld		(ActLogOut+43)
#define ActNewHld		(ActLogOut+44)
#define ActRemHld		(ActLogOut+45)
#define ActChgHldPlc		(ActLogOut+46)
#define ActChgHldTyp		(ActLogOut+47)
#define ActChgHldStrDat		(ActLogOut+48)
#define ActChgHldEndDat		(ActLogOut+49)
#define ActRenHld		(ActLogOut+50)
#define ActAskNewAdm		(ActLogOut+51)
#define ActNewAdm		(ActLogOut+52)
#define ActAskRemAdm		(ActLogOut+53)
#define ActRemAdm		(ActLogOut+54)
#define ActNewDegTyp		(ActLogOut+55)
#define ActRemDegTyp		(ActLogOut+56)
#define ActRenDegTyp		(ActLogOut+57)
#define ActNewDeg		(ActLogOut+58)
#define ActRemDeg		(ActLogOut+59)
#define ActRenDegSho		(ActLogOut+60)
#define ActRenDegFul		(ActLogOut+61)
#define ActChgDegTyp		(ActLogOut+62)
#define ActChgDegIns		(ActLogOut+63)
#define ActChgDegPlc		(ActLogOut+64)
#define ActChgDegFstYea		(ActLogOut+65)
#define ActChgDegLstYea		(ActLogOut+66)
#define ActChgDegOptYea		(ActLogOut+67)
#define ActChgDegLog		(ActLogOut+68)
#define ActChgDegWWW		(ActLogOut+69)
#define ActNewCrs		(ActLogOut+70)
#define ActRemCrs		(ActLogOut+71)
#define ActChgCrsDeg		(ActLogOut+72)
#define ActChgCrsYea		(ActLogOut+73)
#define ActChgCrsSem		(ActLogOut+74)
#define ActRenCrsSho		(ActLogOut+75)
#define ActRenCrsFul		(ActLogOut+76)
#define ActEdiLnk		(ActLogOut+77)
#define ActNewLnk		(ActLogOut+78)
#define ActRemLnk		(ActLogOut+79)
#define ActRenLnkSho		(ActLogOut+80)
#define ActRenLnkFul		(ActLogOut+81)
#define ActChgLnkWWW		(ActLogOut+82)

/****************************************************************************/
/******************************** Course tab ********************************/
/****************************************************************************/
// Actions in menu
#define ActSeeTchGui		(ActChgLnkWWW+  1)
#define ActSeeCal		(ActChgLnkWWW+  2)
#define ActSeeCrsTimTbl		(ActChgLnkWWW+  3)
#define ActSeeSylLec		(ActChgLnkWWW+  4)
#define ActSeeSylPra		(ActChgLnkWWW+  5)
#define ActAskSeeDow		(ActChgLnkWWW+  6)
#define ActAskAdmDow		(ActChgLnkWWW+  7)
#define ActAskAdmCom		(ActChgLnkWWW+  8)
#define ActSeeBib		(ActChgLnkWWW+  9)
#define ActSeeFAQ		(ActChgLnkWWW+ 10)
#define ActSeeCrsLnk		(ActChgLnkWWW+ 11)
// Secondary actions
#define ActEdiTchGui		(ActChgLnkWWW+ 12)
#define ActPrnCal		(ActChgLnkWWW+ 13)
#define ActPrnCrsTimTbl		(ActChgLnkWWW+ 14)
#define ActEdiCrsTimTbl		(ActChgLnkWWW+ 15)
#define ActChgCrsTimTbl		(ActChgLnkWWW+ 16)
#define ActEdiSylLec		(ActChgLnkWWW+ 17)
#define ActEdiSylPra		(ActChgLnkWWW+ 18)
#define ActDelItmSylLec		(ActChgLnkWWW+ 19)
#define ActDelItmSylPra		(ActChgLnkWWW+ 20)
#define ActUp_IteSylLec		(ActChgLnkWWW+ 21)
#define ActUp_IteSylPra		(ActChgLnkWWW+ 22)
#define ActDwnIteSylLec		(ActChgLnkWWW+ 23)
#define ActDwnIteSylPra		(ActChgLnkWWW+ 24)
#define ActRgtIteSylLec		(ActChgLnkWWW+ 25)
#define ActRgtIteSylPra		(ActChgLnkWWW+ 26)
#define ActLftIteSylLec		(ActChgLnkWWW+ 27)
#define ActLftIteSylPra		(ActChgLnkWWW+ 28)
#define ActInsIteSylLec		(ActChgLnkWWW+ 29)
#define ActInsIteSylPra		(ActChgLnkWWW+ 30)
#define ActModIteSylLec		(ActChgLnkWWW+ 31)
#define ActModIteSylPra		(ActChgLnkWWW+ 32)

#define ActSeeDowCrs		(ActChgLnkWWW+ 33)
#define ActExpSeeDowCrs		(ActChgLnkWWW+ 34)
#define ActConSeeDowCrs		(ActChgLnkWWW+ 35)

#define ActSeeDowGrp		(ActChgLnkWWW+ 36)
#define ActExpSeeDowGrp		(ActChgLnkWWW+ 37)
#define ActConSeeDowGrp		(ActChgLnkWWW+ 38)

#define ActAdmDowCrs		(ActChgLnkWWW+ 39)
#define ActAskRemFilDowCrs	(ActChgLnkWWW+ 40)
#define ActRemFilDowCrs		(ActChgLnkWWW+ 41)
#define ActRemFolDowCrs		(ActChgLnkWWW+ 42)
#define ActCopDowCrs		(ActChgLnkWWW+ 43)
#define ActPasDowCrs		(ActChgLnkWWW+ 44)
#define ActRemTreDowCrs		(ActChgLnkWWW+ 45)
#define ActFrmCreDowCrs		(ActChgLnkWWW+ 46)
#define ActRecFolDowCrs		(ActChgLnkWWW+ 47)
#define ActRenFolDowCrs		(ActChgLnkWWW+ 48)
#define ActRecFilDowCrs		(ActChgLnkWWW+ 49)
#define ActExpAdmDowCrs		(ActChgLnkWWW+ 50)
#define ActConAdmDowCrs		(ActChgLnkWWW+ 51)
#define ActShoDowCrs		(ActChgLnkWWW+ 52)
#define ActHidDowCrs		(ActChgLnkWWW+ 53)

#define ActAdmDowGrp		(ActChgLnkWWW+ 54)
#define ActAskRemFilDowGrp	(ActChgLnkWWW+ 55)
#define ActRemFilDowGrp		(ActChgLnkWWW+ 56)
#define ActRemFolDowGrp		(ActChgLnkWWW+ 57)
#define ActCopDowGrp		(ActChgLnkWWW+ 58)
#define ActPasDowGrp		(ActChgLnkWWW+ 59)
#define ActRemTreDowGrp		(ActChgLnkWWW+ 60)
#define ActFrmCreDowGrp		(ActChgLnkWWW+ 61)
#define ActRecFolDowGrp		(ActChgLnkWWW+ 62)
#define ActRenFolDowGrp		(ActChgLnkWWW+ 63)
#define ActRecFilDowGrp		(ActChgLnkWWW+ 64)
#define ActExpAdmDowGrp		(ActChgLnkWWW+ 65)
#define ActConAdmDowGrp		(ActChgLnkWWW+ 66)
#define ActShoDowGrp		(ActChgLnkWWW+ 67)
#define ActHidDowGrp		(ActChgLnkWWW+ 68)

#define ActAdmComCrs		(ActChgLnkWWW+ 69)
#define ActAskRemFilComCrs	(ActChgLnkWWW+ 70)
#define ActRemFilComCrs		(ActChgLnkWWW+ 71)
#define ActRemFolComCrs		(ActChgLnkWWW+ 72)
#define ActCopComCrs		(ActChgLnkWWW+ 73)
#define ActPasComCrs		(ActChgLnkWWW+ 74)
#define ActRemTreComCrs		(ActChgLnkWWW+ 75)
#define ActFrmCreComCrs		(ActChgLnkWWW+ 76)
#define ActRecFolComCrs		(ActChgLnkWWW+ 77)
#define ActRenFolComCrs		(ActChgLnkWWW+ 78)
#define ActRecFilComCrs		(ActChgLnkWWW+ 79)
#define ActExpComCrs		(ActChgLnkWWW+ 80)
#define ActConComCrs		(ActChgLnkWWW+ 81)

#define ActAdmComGrp		(ActChgLnkWWW+ 82)
#define ActAskRemFilComGrp	(ActChgLnkWWW+ 83)
#define ActRemFilComGrp		(ActChgLnkWWW+ 84)
#define ActRemFolComGrp		(ActChgLnkWWW+ 85)
#define ActCopComGrp		(ActChgLnkWWW+ 86)
#define ActPasComGrp		(ActChgLnkWWW+ 87)
#define ActRemTreComGrp		(ActChgLnkWWW+ 88)
#define ActFrmCreComGrp		(ActChgLnkWWW+ 89)
#define ActRecFolComGrp		(ActChgLnkWWW+ 90)
#define ActRenFolComGrp		(ActChgLnkWWW+ 91)
#define ActRecFilComGrp		(ActChgLnkWWW+ 92)
#define ActExpComGrp		(ActChgLnkWWW+ 93)
#define ActConComGrp		(ActChgLnkWWW+ 94)

#define ActEdiBib		(ActChgLnkWWW+ 95)
#define ActEdiFAQ		(ActChgLnkWWW+ 96)
#define ActEdiCrsLnk		(ActChgLnkWWW+ 97)
#define ActSelInfSrcTchGui	(ActChgLnkWWW+ 98)
#define ActSelInfSrcSylLec	(ActChgLnkWWW+ 99)
#define ActSelInfSrcSylPra	(ActChgLnkWWW+100)
#define ActSelInfSrcBib		(ActChgLnkWWW+101)
#define ActSelInfSrcFAQ		(ActChgLnkWWW+102)
#define ActSelInfSrcCrsLnk	(ActChgLnkWWW+103)
#define ActRecURLTchGui		(ActChgLnkWWW+104)
#define ActRecURLSylLec		(ActChgLnkWWW+105)
#define ActRecURLSylPra		(ActChgLnkWWW+106)
#define ActRecURLBib		(ActChgLnkWWW+107)
#define ActRecURLFAQ		(ActChgLnkWWW+108)
#define ActRecURLCrsLnk		(ActChgLnkWWW+109)
#define ActRecPagTchGui		(ActChgLnkWWW+110)
#define ActRecPagSylLec		(ActChgLnkWWW+111)
#define ActRecPagSylPra		(ActChgLnkWWW+112)
#define ActRecPagBib		(ActChgLnkWWW+113)
#define ActRecPagFAQ		(ActChgLnkWWW+114)
#define ActRecPagCrsLnk		(ActChgLnkWWW+115)
#define ActEditorTchGui		(ActChgLnkWWW+116)
#define ActEditorSylLec		(ActChgLnkWWW+117)
#define ActEditorSylPra		(ActChgLnkWWW+118)
#define ActEditorBib		(ActChgLnkWWW+119)
#define ActEditorFAQ		(ActChgLnkWWW+120)
#define ActEditorCrsLnk		(ActChgLnkWWW+121)
#define ActTxtEdiTchGui		(ActChgLnkWWW+122)
#define ActTxtEdiSylLec		(ActChgLnkWWW+123)
#define ActTxtEdiSylPra		(ActChgLnkWWW+124)
#define ActTxtEdiBib		(ActChgLnkWWW+125)
#define ActTxtEdiFAQ		(ActChgLnkWWW+126)
#define ActTxtEdiCrsLnk		(ActChgLnkWWW+127)
#define ActRecTxtTchGui		(ActChgLnkWWW+128)
#define ActRecTxtSylLec		(ActChgLnkWWW+129)
#define ActRecTxtSylPra		(ActChgLnkWWW+130)
#define ActRecTxtBib		(ActChgLnkWWW+131)
#define ActRecTxtFAQ		(ActChgLnkWWW+132)
#define ActRecTxtCrsLnk		(ActChgLnkWWW+133)
/****************************************************************************/
/***************************** Assessment tab *******************************/
/****************************************************************************/
// Actions in menu
#define ActSeeAss		(ActRecTxtCrsLnk+  1)
#define ActSeeAsg		(ActRecTxtCrsLnk+  2)
#define ActSeeCrdCrs		(ActRecTxtCrsLnk+  3)
#define ActEdiAsgWrkUsr		(ActRecTxtCrsLnk+  4)
#define ActReqAsgWrkCrs	(ActRecTxtCrsLnk+  5)
#define ActReqTst		(ActRecTxtCrsLnk+  6)
#define ActWriTstQst		(ActRecTxtCrsLnk+  7)
#define ActEdiTstQst		(ActRecTxtCrsLnk+  8)
#define ActCfgTst		(ActRecTxtCrsLnk+  9)
#define ActSeeExaAnn		(ActRecTxtCrsLnk+ 10)
#define ActAskSeeAss		(ActRecTxtCrsLnk+ 11)
#define ActAskAdmAss		(ActRecTxtCrsLnk+ 12)
// Secondary actions
#define ActEdiAss		(ActRecTxtCrsLnk+ 13)
#define ActSelInfSrcAss		(ActRecTxtCrsLnk+ 14)
#define ActRecURLAss		(ActRecTxtCrsLnk+ 15)
#define ActRecPagAss		(ActRecTxtCrsLnk+ 16)
#define ActEditorAss		(ActRecTxtCrsLnk+ 17)
#define ActTxtEdiAss		(ActRecTxtCrsLnk+ 18)
#define ActRecTxtAss		(ActRecTxtCrsLnk+ 19)

#define ActFrmNewAsg		(ActRecTxtCrsLnk+ 20)
#define ActEdiOneAsg		(ActRecTxtCrsLnk+ 21)
#define ActNewAsg		(ActRecTxtCrsLnk+ 22)
#define ActChgAsg		(ActRecTxtCrsLnk+ 23)
#define ActAskRemAsg		(ActRecTxtCrsLnk+ 24)
#define ActRemAsg		(ActRecTxtCrsLnk+ 25)

#define ActRecCrdCrs		(ActRecTxtCrsLnk+ 26)
#define ActEdiAsgWrkCrs		(ActRecTxtCrsLnk+ 27)

#define ActAskRemFilAsgUsr	(ActRecTxtCrsLnk+ 28)
#define ActRemFilAsgUsr		(ActRecTxtCrsLnk+ 29)
#define ActRemFolAsgUsr		(ActRecTxtCrsLnk+ 30)
#define ActCopAsgUsr		(ActRecTxtCrsLnk+ 31)
#define ActPasAsgUsr		(ActRecTxtCrsLnk+ 32)
#define ActRemTreAsgUsr		(ActRecTxtCrsLnk+ 33)
#define ActFrmCreAsgUsr		(ActRecTxtCrsLnk+ 34)
#define ActRecFolAsgUsr		(ActRecTxtCrsLnk+ 35)
#define ActRenFolAsgUsr		(ActRecTxtCrsLnk+ 36)
#define ActRecFilAsgUsr		(ActRecTxtCrsLnk+ 37)
#define ActExpAsgUsr		(ActRecTxtCrsLnk+ 38)
#define ActConAsgUsr		(ActRecTxtCrsLnk+ 39)

#define ActAskRemFilWrkUsr	(ActRecTxtCrsLnk+ 40)
#define ActRemFilWrkUsr		(ActRecTxtCrsLnk+ 41)
#define ActRemFolWrkUsr		(ActRecTxtCrsLnk+ 42)
#define ActCopWrkUsr		(ActRecTxtCrsLnk+ 43)
#define ActPasWrkUsr		(ActRecTxtCrsLnk+ 44)
#define ActRemTreWrkUsr		(ActRecTxtCrsLnk+ 45)
#define ActFrmCreWrkUsr		(ActRecTxtCrsLnk+ 46)
#define ActRecFolWrkUsr		(ActRecTxtCrsLnk+ 47)
#define ActRenFolWrkUsr		(ActRecTxtCrsLnk+ 48)
#define ActRecFilWrkUsr		(ActRecTxtCrsLnk+ 49)
#define ActExpWrkUsr		(ActRecTxtCrsLnk+ 50)
#define ActConWrkUsr		(ActRecTxtCrsLnk+ 51)

#define ActAskRemFilAsgCrs	(ActRecTxtCrsLnk+ 52)
#define ActRemFilAsgCrs		(ActRecTxtCrsLnk+ 53)
#define ActRemFolAsgCrs		(ActRecTxtCrsLnk+ 54)
#define ActCopAsgCrs		(ActRecTxtCrsLnk+ 55)
#define ActPasAsgCrs		(ActRecTxtCrsLnk+ 56)
#define ActRemTreAsgCrs		(ActRecTxtCrsLnk+ 57)
#define ActFrmCreAsgCrs		(ActRecTxtCrsLnk+ 58)
#define ActRecFolAsgCrs		(ActRecTxtCrsLnk+ 59)
#define ActRenFolAsgCrs		(ActRecTxtCrsLnk+ 60)
#define ActRecFilAsgCrs		(ActRecTxtCrsLnk+ 61)
#define ActExpAsgCrs		(ActRecTxtCrsLnk+ 62)
#define ActConAsgCrs		(ActRecTxtCrsLnk+ 63)

#define ActAskRemFilWrkCrs	(ActRecTxtCrsLnk+ 64)
#define ActRemFilWrkCrs		(ActRecTxtCrsLnk+ 65)
#define ActRemFolWrkCrs		(ActRecTxtCrsLnk+ 66)
#define ActCopWrkCrs		(ActRecTxtCrsLnk+ 67)
#define ActPasWrkCrs		(ActRecTxtCrsLnk+ 68)
#define ActRemTreWrkCrs		(ActRecTxtCrsLnk+ 69)
#define ActFrmCreWrkCrs		(ActRecTxtCrsLnk+ 70)
#define ActRecFolWrkCrs		(ActRecTxtCrsLnk+ 71)
#define ActRenFolWrkCrs		(ActRecTxtCrsLnk+ 72)
#define ActRecFilWrkCrs		(ActRecTxtCrsLnk+ 73)
#define ActExpWrkCrs		(ActRecTxtCrsLnk+ 74)
#define ActConWrkCrs		(ActRecTxtCrsLnk+ 75)

#define ActSeeTst		(ActRecTxtCrsLnk+ 76)
#define ActAssTst		(ActRecTxtCrsLnk+ 77)
#define ActLstTstQst		(ActRecTxtCrsLnk+ 78)
#define ActRecTstQst		(ActRecTxtCrsLnk+ 79)
#define ActRemTstQst		(ActRecTxtCrsLnk+ 80)
#define ActShfTstQst		(ActRecTxtCrsLnk+ 81)
#define ActEnableTag		(ActRecTxtCrsLnk+ 82)
#define ActDisableTag		(ActRecTxtCrsLnk+ 83)
#define ActRenTag		(ActRecTxtCrsLnk+ 84)
#define ActRecCfgTst		(ActRecTxtCrsLnk+ 85)
#define ActEdiExaAnn		(ActRecTxtCrsLnk+ 86)
#define ActRecExaAnn		(ActRecTxtCrsLnk+ 87)
#define ActPrnExaAnn		(ActRecTxtCrsLnk+ 88)
#define ActRemExaAnn		(ActRecTxtCrsLnk+ 89)

#define ActSeeAssCrs		(ActRecTxtCrsLnk+ 90)
#define ActExpSeeAssCrs		(ActRecTxtCrsLnk+ 91)
#define ActConSeeAssCrs		(ActRecTxtCrsLnk+ 92)
#define ActSeeMyAssCrs		(ActRecTxtCrsLnk+ 93)

#define ActSeeAssGrp		(ActRecTxtCrsLnk+ 94)
#define ActExpSeeAssGrp		(ActRecTxtCrsLnk+ 95)
#define ActConSeeAssGrp		(ActRecTxtCrsLnk+ 96)
#define ActSeeMyAssGrp		(ActRecTxtCrsLnk+ 97)

#define ActAdmAssCrs		(ActRecTxtCrsLnk+ 98)
#define ActAskRemFilAssCrs	(ActRecTxtCrsLnk+ 99)
#define ActRemFilAssCrs		(ActRecTxtCrsLnk+100)
#define ActRemFolAssCrs		(ActRecTxtCrsLnk+101)
#define ActCopAssCrs		(ActRecTxtCrsLnk+102)
#define ActPasAssCrs		(ActRecTxtCrsLnk+103)
#define ActRemTreAssCrs		(ActRecTxtCrsLnk+104)
#define ActFrmCreAssCrs		(ActRecTxtCrsLnk+105)
#define ActRecFolAssCrs		(ActRecTxtCrsLnk+106)
#define ActRenFolAssCrs		(ActRecTxtCrsLnk+107)
#define ActRecFilAssCrs		(ActRecTxtCrsLnk+108)
#define ActExpAdmAssCrs		(ActRecTxtCrsLnk+109)
#define ActConAdmAssCrs		(ActRecTxtCrsLnk+110)
#define ActChgNumRowHeaCrs	(ActRecTxtCrsLnk+111)
#define ActChgNumRowFooCrs	(ActRecTxtCrsLnk+112)

#define ActAdmAssGrp		(ActRecTxtCrsLnk+113)
#define ActAskRemFilAssGrp	(ActRecTxtCrsLnk+114)
#define ActRemFilAssGrp		(ActRecTxtCrsLnk+115)
#define ActRemFolAssGrp		(ActRecTxtCrsLnk+116)
#define ActCopAssGrp		(ActRecTxtCrsLnk+117)
#define ActPasAssGrp		(ActRecTxtCrsLnk+118)
#define ActRemTreAssGrp		(ActRecTxtCrsLnk+119)
#define ActFrmCreAssGrp		(ActRecTxtCrsLnk+120)
#define ActRecFolAssGrp		(ActRecTxtCrsLnk+121)
#define ActRenFolAssGrp		(ActRecTxtCrsLnk+122)
#define ActRecFilAssGrp		(ActRecTxtCrsLnk+123)
#define ActExpAdmAssGrp		(ActRecTxtCrsLnk+124)
#define ActConAdmAssGrp		(ActRecTxtCrsLnk+125)
#define ActChgNumRowHeaGrp	(ActRecTxtCrsLnk+126)
#define ActChgNumRowFooGrp	(ActRecTxtCrsLnk+127)
/****************************************************************************/
/******************************* Users tab **********************************/
/****************************************************************************/
// Actions in menu
#define ActSeeStd		(ActChgNumRowFooGrp+ 1)
#define ActGetExtLstStd		(ActChgNumRowFooGrp+ 2)
#define ActSeeTch		(ActChgNumRowFooGrp+ 3)
#define ActReqCrdCrsStd		(ActChgNumRowFooGrp+ 4)
#define ActEdiFieCrd		(ActChgNumRowFooGrp+ 5)
#define ActSeeCrdCrsTch		(ActChgNumRowFooGrp+ 6)
#define ActSeeTut		(ActChgNumRowFooGrp+ 7)
#define ActReqEdiGrp		(ActChgNumRowFooGrp+ 8)
#define ActReqSelGrp		(ActChgNumRowFooGrp+ 9)
#define ActReqNewUsrCrs		(ActChgNumRowFooGrp+10)

#define ActMdfSevStdCrs		(ActChgNumRowFooGrp+11)

#define ActReqPwdOthUsr		(ActChgNumRowFooGrp+12)
#define ActReqPhoUsr		(ActChgNumRowFooGrp+13)
#define ActReqRemUsrCrs		(ActChgNumRowFooGrp+14)
#define ActAskRemAllStd		(ActChgNumRowFooGrp+15)
#define ActReqDNIRemGbl		(ActChgNumRowFooGrp+16)
#define ActAskRemOldUsr		(ActChgNumRowFooGrp+17)
// Actions secundaria
#define ActPrnStdPho		(ActChgNumRowFooGrp+18)
#define ActPrnTchPho		(ActChgNumRowFooGrp+19)
#define ActLstStdAll		(ActChgNumRowFooGrp+20)
#define ActLstTchAll		(ActChgNumRowFooGrp+21)
#define ActSeeCrdCrsStd		(ActChgNumRowFooGrp+22)
#define ActPrnCrdCrsStd		(ActChgNumRowFooGrp+23)
#define ActPrnCrdCrsTch		(ActChgNumRowFooGrp+24)
#define ActRecCrdCrsOthUsr	(ActChgNumRowFooGrp+25)
#define ActNewFie		(ActChgNumRowFooGrp+26)
#define ActReqRemFie		(ActChgNumRowFooGrp+27)
#define ActRemFie		(ActChgNumRowFooGrp+28)
#define ActRenFie		(ActChgNumRowFooGrp+29)
#define ActChgRowFie		(ActChgNumRowFooGrp+30)
#define ActChgVisFie		(ActChgNumRowFooGrp+31)
#define ActNewGrpTyp		(ActChgNumRowFooGrp+32)
#define ActReqRemGrpTyp		(ActChgNumRowFooGrp+33)
#define ActRemGrpTyp		(ActChgNumRowFooGrp+34)
#define ActRenGrpTyp		(ActChgNumRowFooGrp+35)
#define ActChgMdtGrpTyp		(ActChgNumRowFooGrp+36)
#define ActChgMulGrpTyp		(ActChgNumRowFooGrp+37)
#define ActNewGrp		(ActChgNumRowFooGrp+38)
#define ActReqRemGrp		(ActChgNumRowFooGrp+39)
#define ActRemGrp		(ActChgNumRowFooGrp+40)
#define ActOpeGrp		(ActChgNumRowFooGrp+41)
#define ActCloGrp		(ActChgNumRowFooGrp+42)
#define ActEnaFilZonGrp		(ActChgNumRowFooGrp+43)
#define ActDisFilZonGrp		(ActChgNumRowFooGrp+44)
#define ActChgGrpTyp		(ActChgNumRowFooGrp+45)
#define ActRenGrp		(ActChgNumRowFooGrp+46)
#define ActChgMaxStdGrp		(ActChgNumRowFooGrp+47)
#define ActChgGrp		(ActChgNumRowFooGrp+48)
#define ActAskNewUsrCrs		(ActChgNumRowFooGrp+49)
#define ActUsrPho		(ActChgNumRowFooGrp+50)
#define ActDetUsrPho		(ActChgNumRowFooGrp+51)
#define ActUpdUsrPho		(ActChgNumRowFooGrp+52)
#define ActRemUsrPho		(ActChgNumRowFooGrp+53)
#define ActCreOthUsrDat		(ActChgNumRowFooGrp+54)
#define ActUpdOthUsrDat		(ActChgNumRowFooGrp+55)
#define ActRegUsr		(ActChgNumRowFooGrp+56)

#define ActReqAccRegCrs		(ActChgNumRowFooGrp+57)
#define ActAccRegCrs		(ActChgNumRowFooGrp+58)
#define ActRefRegCrs		(ActChgNumRowFooGrp+59)

#define ActRecFrmMdfStdCrs	(ActChgNumRowFooGrp+60)
#define ActFrmPwdOthUsr		(ActChgNumRowFooGrp+61)
#define ActRecPwdOthUsr		(ActChgNumRowFooGrp+62)
#define ActAskRemUsrCrs		(ActChgNumRowFooGrp+63)
#define ActRemUsrCrs		(ActChgNumRowFooGrp+64)
#define ActAskRemUsrGbl		(ActChgNumRowFooGrp+65)
#define ActRemUsrGbl		(ActChgNumRowFooGrp+66)
#define ActRemAllStdCrs		(ActChgNumRowFooGrp+67)
#define ActRemOldUsr		(ActChgNumRowFooGrp+68)
/****************************************************************************/
/******************************* Messages tab *******************************/
/****************************************************************************/
// Actions in menu
#define ActSeeNot		(ActRemOldUsr+  1)
#define ActReqMsgUsr		(ActRemOldUsr+  2)
#define ActSeeSntMsg		(ActRemOldUsr+  3)
#define ActSeeRecMsg		(ActRemOldUsr+  4)
#define ActMaiStd		(ActRemOldUsr+  5)
#define ActSeeFor		(ActRemOldUsr+  6)
#define ActSeeChtRms		(ActRemOldUsr+  7)
// Secondary actions
#define ActWriNot		(ActRemOldUsr+  8)
#define ActRecNot		(ActRemOldUsr+  9)
#define ActHidNot		(ActRemOldUsr+ 10)
#define ActShoNot		(ActRemOldUsr+ 11)
#define ActRemNot		(ActRemOldUsr+ 12)
#define ActSeeNewMsg		(ActRemOldUsr+ 13)
#define ActSeeForCrsUsr		(ActRemOldUsr+ 14)
#define ActSeeForCrsTch		(ActRemOldUsr+ 15)
#define ActSeeForDegUsr		(ActRemOldUsr+ 16)
#define ActSeeForDegTch		(ActRemOldUsr+ 17)
#define ActSeeForCtrUsr		(ActRemOldUsr+ 18)
#define ActSeeForCtrTch		(ActRemOldUsr+ 19)
#define ActSeeForInsUsr		(ActRemOldUsr+ 20)
#define ActSeeForInsTch		(ActRemOldUsr+ 21)
#define ActSeeForGenUsr		(ActRemOldUsr+ 22)
#define ActSeeForGenTch		(ActRemOldUsr+ 23)
#define ActSeeForSWAUsr		(ActRemOldUsr+ 24)
#define ActSeeForSWATch		(ActRemOldUsr+ 25)
#define ActSeePstForCrsUsr	(ActRemOldUsr+ 26)
#define ActSeePstForCrsTch	(ActRemOldUsr+ 27)
#define ActSeePstForDegUsr	(ActRemOldUsr+ 28)
#define ActSeePstForDegTch	(ActRemOldUsr+ 29)
#define ActSeePstForCtrUsr	(ActRemOldUsr+ 30)
#define ActSeePstForCtrTch	(ActRemOldUsr+ 31)
#define ActSeePstForInsUsr	(ActRemOldUsr+ 32)
#define ActSeePstForInsTch	(ActRemOldUsr+ 33)
#define ActSeePstForGenUsr	(ActRemOldUsr+ 34)
#define ActSeePstForGenTch	(ActRemOldUsr+ 35)
#define ActSeePstForSWAUsr	(ActRemOldUsr+ 36)
#define ActSeePstForSWATch	(ActRemOldUsr+ 37)
#define ActRecThrForCrsUsr	(ActRemOldUsr+ 38)
#define ActRecThrForCrsTch	(ActRemOldUsr+ 39)
#define ActRecThrForDegUsr	(ActRemOldUsr+ 40)
#define ActRecThrForDegTch	(ActRemOldUsr+ 41)
#define ActRecThrForCtrUsr	(ActRemOldUsr+ 42)
#define ActRecThrForCtrTch	(ActRemOldUsr+ 43)
#define ActRecThrForInsUsr	(ActRemOldUsr+ 44)
#define ActRecThrForInsTch	(ActRemOldUsr+ 45)
#define ActRecThrForGenUsr	(ActRemOldUsr+ 46)
#define ActRecThrForGenTch	(ActRemOldUsr+ 47)
#define ActRecThrForSWAUsr	(ActRemOldUsr+ 48)
#define ActRecThrForSWATch	(ActRemOldUsr+ 49)
#define ActRecRepForCrsUsr	(ActRemOldUsr+ 50)
#define ActRecRepForCrsTch	(ActRemOldUsr+ 51)
#define ActRecRepForDegUsr	(ActRemOldUsr+ 52)
#define ActRecRepForDegTch	(ActRemOldUsr+ 53)
#define ActRecRepForCtrUsr	(ActRemOldUsr+ 54)
#define ActRecRepForCtrTch	(ActRemOldUsr+ 55)
#define ActRecRepForInsUsr	(ActRemOldUsr+ 56)
#define ActRecRepForInsTch	(ActRemOldUsr+ 57)
#define ActRecRepForGenUsr	(ActRemOldUsr+ 58)
#define ActRecRepForGenTch	(ActRemOldUsr+ 59)
#define ActRecRepForSWAUsr	(ActRemOldUsr+ 60)
#define ActRecRepForSWATch	(ActRemOldUsr+ 61)
#define ActReqDelThrCrsUsr	(ActRemOldUsr+ 62)
#define ActReqDelThrCrsTch	(ActRemOldUsr+ 63)
#define ActReqDelThrDegUsr	(ActRemOldUsr+ 64)
#define ActReqDelThrDegTch	(ActRemOldUsr+ 65)
#define ActReqDelThrCtrUsr	(ActRemOldUsr+ 66)
#define ActReqDelThrCtrTch	(ActRemOldUsr+ 67)
#define ActReqDelThrInsUsr	(ActRemOldUsr+ 68)
#define ActReqDelThrInsTch	(ActRemOldUsr+ 69)
#define ActReqDelThrGenUsr	(ActRemOldUsr+ 70)
#define ActReqDelThrGenTch	(ActRemOldUsr+ 71)
#define ActReqDelThrSWAUsr	(ActRemOldUsr+ 72)
#define ActReqDelThrSWATch	(ActRemOldUsr+ 73)
#define ActDelThrForCrsUsr	(ActRemOldUsr+ 74)
#define ActDelThrForCrsTch	(ActRemOldUsr+ 75)
#define ActDelThrForDegUsr	(ActRemOldUsr+ 76)
#define ActDelThrForDegTch	(ActRemOldUsr+ 77)
#define ActDelThrForCtrUsr	(ActRemOldUsr+ 78)
#define ActDelThrForCtrTch	(ActRemOldUsr+ 79)
#define ActDelThrForInsUsr	(ActRemOldUsr+ 80)
#define ActDelThrForInsTch	(ActRemOldUsr+ 81)
#define ActDelThrForGenUsr	(ActRemOldUsr+ 82)
#define ActDelThrForGenTch	(ActRemOldUsr+ 83)
#define ActDelThrForSWAUsr	(ActRemOldUsr+ 84)
#define ActDelThrForSWATch	(ActRemOldUsr+ 85)
#define ActCutThrForCrsUsr	(ActRemOldUsr+ 86)
#define ActCutThrForCrsTch	(ActRemOldUsr+ 87)
#define ActCutThrForDegUsr	(ActRemOldUsr+ 88)
#define ActCutThrForDegTch	(ActRemOldUsr+ 89)
#define ActCutThrForCtrUsr	(ActRemOldUsr+ 90)
#define ActCutThrForCtrTch	(ActRemOldUsr+ 91)
#define ActCutThrForInsUsr	(ActRemOldUsr+ 92)
#define ActCutThrForInsTch	(ActRemOldUsr+ 93)
#define ActCutThrForGenUsr	(ActRemOldUsr+ 94)
#define ActCutThrForGenTch	(ActRemOldUsr+ 95)
#define ActCutThrForSWAUsr	(ActRemOldUsr+ 96)
#define ActCutThrForSWATch	(ActRemOldUsr+ 97)
#define ActPasThrForCrsUsr	(ActRemOldUsr+ 98)
#define ActPasThrForCrsTch	(ActRemOldUsr+ 99)
#define ActPasThrForDegUsr	(ActRemOldUsr+100)
#define ActPasThrForDegTch	(ActRemOldUsr+101)
#define ActPasThrForCtrUsr	(ActRemOldUsr+102)
#define ActPasThrForCtrTch	(ActRemOldUsr+103)
#define ActPasThrForInsUsr	(ActRemOldUsr+104)
#define ActPasThrForInsTch	(ActRemOldUsr+105)
#define ActPasThrForGenUsr	(ActRemOldUsr+106)
#define ActPasThrForGenTch	(ActRemOldUsr+107)
#define ActPasThrForSWAUsr	(ActRemOldUsr+108)
#define ActPasThrForSWATch	(ActRemOldUsr+109)
#define ActDelPstForCrsUsr	(ActRemOldUsr+110)
#define ActDelPstForCrsTch	(ActRemOldUsr+111)
#define ActDelPstForDegUsr	(ActRemOldUsr+112)
#define ActDelPstForDegTch	(ActRemOldUsr+113)
#define ActDelPstForCtrUsr	(ActRemOldUsr+114)
#define ActDelPstForCtrTch	(ActRemOldUsr+115)
#define ActDelPstForInsUsr	(ActRemOldUsr+116)
#define ActDelPstForInsTch	(ActRemOldUsr+117)
#define ActDelPstForGenUsr	(ActRemOldUsr+118)
#define ActDelPstForGenTch	(ActRemOldUsr+119)
#define ActDelPstForSWAUsr	(ActRemOldUsr+120)
#define ActDelPstForSWATch	(ActRemOldUsr+121)
#define ActEnbPstForCrsUsr	(ActRemOldUsr+122)
#define ActEnbPstForCrsTch	(ActRemOldUsr+123)
#define ActEnbPstForDegUsr	(ActRemOldUsr+124)
#define ActEnbPstForDegTch	(ActRemOldUsr+125)
#define ActEnbPstForCtrUsr	(ActRemOldUsr+126)
#define ActEnbPstForCtrTch	(ActRemOldUsr+127)
#define ActEnbPstForInsUsr	(ActRemOldUsr+128)
#define ActEnbPstForInsTch	(ActRemOldUsr+129)
#define ActEnbPstForGenUsr	(ActRemOldUsr+130)
#define ActEnbPstForGenTch	(ActRemOldUsr+131)
#define ActEnbPstForSWAUsr	(ActRemOldUsr+132)
#define ActEnbPstForSWATch	(ActRemOldUsr+133)
#define ActDisPstForCrsUsr	(ActRemOldUsr+134)
#define ActDisPstForCrsTch	(ActRemOldUsr+135)
#define ActDisPstForDegUsr	(ActRemOldUsr+136)
#define ActDisPstForDegTch	(ActRemOldUsr+137)
#define ActDisPstForCtrUsr	(ActRemOldUsr+138)
#define ActDisPstForCtrTch	(ActRemOldUsr+139)
#define ActDisPstForInsUsr	(ActRemOldUsr+140)
#define ActDisPstForInsTch	(ActRemOldUsr+141)
#define ActDisPstForGenUsr	(ActRemOldUsr+142)
#define ActDisPstForGenTch	(ActRemOldUsr+143)
#define ActDisPstForSWAUsr	(ActRemOldUsr+144)
#define ActDisPstForSWATch	(ActRemOldUsr+145)
#define ActRecMsgUsr		(ActRemOldUsr+146)
#define ActReqDelAllSntMsg	(ActRemOldUsr+147)
#define ActReqDelAllRecMsg	(ActRemOldUsr+148)
#define ActDelAllSntMsg		(ActRemOldUsr+149)
#define ActDelAllRecMsg		(ActRemOldUsr+150)
#define ActDelSntMsg		(ActRemOldUsr+151)
#define ActDelRecMsg		(ActRemOldUsr+152)
#define ActExpSntMsg		(ActRemOldUsr+153)
#define ActExpRecMsg		(ActRemOldUsr+154)
#define ActCht			(ActRemOldUsr+155)
/****************************************************************************/
/***************************** Statistics tab *******************************/
/****************************************************************************/
// Actions in menu
#define ActReqAccCrs		(ActCht+ 1)
#define ActReqAccGbl		(ActCht+ 2)
#define ActReqUseGbl		(ActCht+ 3)
#define ActReqStaCrs		(ActCht+ 4)
#define ActSeePhoDeg		(ActCht+ 5)
// Secondary actions
#define ActSeeAccCrs		(ActCht+ 6)
#define ActSeeAccGbl		(ActCht+ 7)
#define ActSeeUseGbl		(ActCht+ 8)
#define ActSeeStaCrs		(ActCht+ 9)
#define ActPrnPhoDeg		(ActCht+10)
#define ActCalPhoDeg		(ActCht+11)
/****************************************************************************/
/******************************* Personal tab *******************************/
/****************************************************************************/
// Actions in menu
#define ActFrmSndNewPwd		(ActCalPhoDeg+ 1)
#define ActFrmChgPwd		(ActCalPhoDeg+ 2)
#define ActFrmNic		(ActCalPhoDeg+ 3)
#define ActReqEdiCrdCom		(ActCalPhoDeg+ 4)
#define ActReqMyPho		(ActCalPhoDeg+ 5)
#define ActEdiPrf		(ActCalPhoDeg+ 6)
#define ActSeeMyTimTbl		(ActCalPhoDeg+ 7)
#define ActEdiTut		(ActCalPhoDeg+ 8)
#define AccAdmMlt		(ActCalPhoDeg+ 9)
// Secondary actions
#define ActSndNewPwd		(ActCalPhoDeg+10)
#define ActRecPwd		(ActCalPhoDeg+11)
#define ActRecNic		(ActCalPhoDeg+12)
#define ActActMyData		(ActCalPhoDeg+13)
#define ActDetMyPho		(ActCalPhoDeg+14)
#define ActUpdMyPho		(ActCalPhoDeg+15)
#define ActRemMyPho		(ActCalPhoDeg+16)

#define ActChgThe		(ActCalPhoDeg+17)
#define ActChgLan		(ActCalPhoDeg+18)
#define ActChgCol		(ActCalPhoDeg+19)
#define ActHidLftCol		(ActCalPhoDeg+20)
#define ActHidRgtCol		(ActCalPhoDeg+21)
#define ActShoLftCol		(ActCalPhoDeg+22)
#define ActShoRgtCol		(ActCalPhoDeg+23)
#define ActChgSecIco		(ActCalPhoDeg+24)
#define ActChgPubPho		(ActCalPhoDeg+25)
#define ActChgNotNewMsg		(ActCalPhoDeg+26)

#define ActPrnMyTimTbl		(ActCalPhoDeg+27)
#define ActChgTut		(ActCalPhoDeg+28)
#define ActAskRemFilBrf		(ActCalPhoDeg+29)
#define ActRemFilBrf		(ActCalPhoDeg+30)
#define ActRemFolBrf		(ActCalPhoDeg+31)
#define ActCopBrf		(ActCalPhoDeg+32)
#define ActPasBrf		(ActCalPhoDeg+33)
#define ActRemTreBrf		(ActCalPhoDeg+34)
#define ActFrmCreBrf		(ActCalPhoDeg+35)
#define ActRecFolBrf		(ActCalPhoDeg+36)
#define ActRenFolBrf		(ActCalPhoDeg+37)
#define ActRecFilBrf		(ActCalPhoDeg+38)
#define ActExpBrf		(ActCalPhoDeg+39)
#define ActConBrf		(ActCalPhoDeg+40)
/****************************************************************************/
/******************************* Plugins tab ********************************/
/****************************************************************************/
// Actions in menu
#define ActLstPlg		(ActConBrf+ 1)
// Secondary actions
#define ActEdiPlg		(ActConBrf+ 2)
#define ActNewPlg		(ActConBrf+ 3)
#define ActRemPlg		(ActConBrf+ 4)
#define ActRenPlg		(ActConBrf+ 5)
#define ActChgPlgDes		(ActConBrf+ 6)
#define ActChgPlgLog		(ActConBrf+ 7)
#define ActChgPlgURL		(ActConBrf+ 8)
#define ActChgPlgIP		(ActConBrf+ 9)

/****************************************************************************/
/******************************* Public types *******************************/
/****************************************************************************/

struct Tabs
  {
   struct
     {
      int FirstOption;
      int LastOption;
     } Menu;
   char *Str;
   char *IconOff;
   char *IconOn;
   unsigned PermisIfIBelongToCrs;
   unsigned PermisIfIDontBelongToCrs;
   unsigned PermisIfNoCrsSelected;
  };

struct Actions
  {
   signed int IndexInMenu;
   const char *Str;
   Act_Tab_t Tab;
   Act_Action_t SuperAction;
   unsigned PermisIfIBelongToCrs;
   unsigned PermisIfIDontBelongToCrs;
   unsigned PermisIfNoCrsSelected;
   bool ExecuteLockfile;
   Act_BrowserWindow_t BrowserWindow;
   void (*FunctionPriori)();
   void (*FunctionPosteriori)();
   void (*FunctionExtraParams)();
   const char *LogMessage;
   const char *Icon;
  };

/****************************************************************************/
/***************************** Public prototypes ****************************/
/****************************************************************************/

const char *Act_GetTitleAction (Act_Action_t Action);
void Act_GetBreadcrumbStrForAction (Act_Action_t Action,Txt_Language_t Language,bool HTML,char *BreadcrumbStr);
void Act_FormStart (Act_Action_t NextAction);
void Act_LinkFormSubmit (Act_BrowserWindow_t Window,const char *MsgWindowStatus,const char *LinkStyle);
void Act_AdjustCurrentAction (void);

#endif
