// swad_cns.h: common constants used in several modules

#ifndef _SWAD_CNS
#define _SWAD_CNS
/*
    SWAD ("Sistema Web de Apoyo a la Docencia" in Spanish,
    "Web System for Teaching Support" in English),
    is a web platform developed at the University of Granada (Spain),
    and used to support university teaching.
    Copyright (C) 1999-2010 Antonio Caas-Vargas
    & Daniel J. Calandria-Hernndez,
    University of Granada (SPAIN) (acanas@ugr.es)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/****************************************************************************/
/********************************* Headers **********************************/
/****************************************************************************/

#include "swad_str.h"

/****************************************************************************/
/***************************** Public constants *****************************/
/****************************************************************************/

#define Cte_MAX_LENGTH_ARGS_SENT_TO_CGI   (1024UL*1024UL-1)     // Ms vale that sobre that no that falte

#define Cte_MAX_LENGTH_WWW	255	// Max. length of a URL

#define Cte_MAX_LENGTH_IP	 40	// Max. bytes of an IP address

#define Cte_MAX_LENGTH_DATE	 (2+1+2+1+4)
#define Cte_MAX_BYTES_DATE		19	// Examples: "20030614143857", "14/06/2003 14:38:57"

#define Cte_MAX_LENGTH_SUBJECT	255
#define Cte_MAX_BYTES_SUBJECT	(Cte_MAX_LENGTH_SUBJECT*Str_MAX_CHARACTER)

#define Cte_MAX_LENGTH_TEXT	(16*1024)
#define Cte_MAX_BYTES_TEXT	(Cte_MAX_LENGTH_TEXT*Str_MAX_CHARACTER)

#define Cte_MAX_LENGTH_STRING	128
#define Cte_MAX_BYTES_STRING	255

#define Cte_MAX_LENGTH_URL	Cte_MAX_LENGTH_STRING
#define Cte_MAX_BYTES_URL	Cte_MAX_BYTES_STRING

/****************************************************************************/
/******************************* Public types *******************************/
/****************************************************************************/

typedef enum
  {
   Cte_QUIET,
   Cte_VERBOSE,
  } Cte_QuietOrVerbose_t;

// Related with names of centres, degrees, courses,...
typedef enum
  {
   Cte_SHORT_NAME,
   Cte_FULL_NAME,
  } Cte_ShortOrFullName_t;

typedef enum
  {
   Cte_NORMAL,
   Cte_DAT,
  } Cte_Content_t;

/****************************************************************************/
/***************************** Public prototypes ****************************/
/****************************************************************************/

#endif
