// swad_ctr.h: centres

#ifndef _SWAD_CTR
#define _SWAD_CTR
/*
    SWAD ("Sistema Web de Apoyo a la Docencia" in Spanish,
    "Web System for Teaching Support" in English),
    is a web platform developed at the University of Granada (Spain),
    and used to support university teaching.
    Copyright (C) 1999-2010 Antonio Caas-Vargas
    & Daniel J. Calandria-Hernndez,
    University of Granada (SPAIN) (acanas@ugr.es)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/****************************************************************************/
/********************************* Headers **********************************/
/****************************************************************************/

#include "swad_cns.h"

/****************************************************************************/
/************************** Public types and constants **********************/
/****************************************************************************/

#define MAX_LENGTH_CENTRE_SHORT_NAME	 32
#define MAX_LENGTH_CENTRE_FULL_NAME	255

struct Centre
  {
   long CtrCod;
   long InsCod;
   char ShortName[MAX_LENGTH_CENTRE_SHORT_NAME+1];
   char FullName[MAX_LENGTH_CENTRE_FULL_NAME+1];
   char WWW[Cte_MAX_LENGTH_WWW+1];
   unsigned NumTchs;
  };

typedef enum {CTR_ORDER_BY_CENTRE=0, CTR_ORDER_BY_NUM_TCHS=1} tCtrsOrderType;

/****************************************************************************/
/***************************** Public prototypes ****************************/
/****************************************************************************/

void Ctr_SeeCentres (void);
void Ctr_PutHiddenParamCtrOrderType (void);
void Ctr_EditCentres (void);
void Ctr_GetListCentres (void);
void Ctr_FreeListCentres (void);
void Ctr_GetDataOfCentreByCod (struct Centre *Ctr);
void Ctr_RemoveCentre (void);
void Ctr_ChangeCentreIns (void);
void Ctr_RenameCentreShort (void);
void Ctr_RenameCentreFull (void);
void Ctr_ChangeCtrWWW (void);
void Ctr_RecFormNewCtr (void);
unsigned Ctr_GetTotalNumberOfCentres (void);
unsigned Ctr_GetNumberOfCentresInInstitution (long InsCod);

#endif
