// swad_ins.h: institutions

#ifndef _SWAD_INS
#define _SWAD_INS
/*
    SWAD ("Sistema Web de Apoyo a la Docencia" in Spanish,
    "Web System for Teaching Support" in English),
    is a web platform developed at the University of Granada (Spain),
    and used to support university teaching.
    Copyright (C) 1999-2010 Antonio Caas-Vargas
    & Daniel J. Calandria-Hernndez,
    University of Granada (SPAIN) (acanas@ugr.es)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/****************************************************************************/
/********************************* Headers **********************************/
/****************************************************************************/

#include "swad_cns.h"

/****************************************************************************/
/************************** Public types and constants **********************/
/****************************************************************************/

#define MAX_INSTITUTIONS_PER_USR	 10 // Used in list of my institutions

#define MAX_LENGTH_INSTITUTION_SHORT_NAME	 32
#define MAX_LENGTH_INSTITUTION_FULL_NAME	255
#define MAX_LENGTH_INSTITUTION_LOGO		 16

struct Institution
  {
   long InsCod;
   char ShortName[MAX_LENGTH_INSTITUTION_SHORT_NAME+1];
   char FullName[MAX_LENGTH_INSTITUTION_FULL_NAME+1];
   char Logo[MAX_LENGTH_INSTITUTION_LOGO+1];
   char WWW[Cte_MAX_LENGTH_WWW+1];
   unsigned NumStds;
   unsigned NumTchs;
   unsigned NumUsrs;
   unsigned NumCtrs;
   unsigned NumDpts;
   unsigned NumDegs;
  };

typedef enum {INS_ORDER_BY_INSTITUTION=0, INS_ORDER_BY_NUM_USRS=1} tInssOrderType;

/****************************************************************************/
/***************************** Public prototypes ****************************/
/****************************************************************************/

void Ins_SeeInstitutions (void);
void Ins_PutHiddenParamInsOrderType (void);
void Ins_EditInstitutions (void);
void Ins_GetListInstitutions (bool GetExtraData);
void Ins_FreeListInstitutions (void);
bool Ins_GetDataOfInstitutionByCod (struct Institution *Ins);
long Ins_GetParamInsCod (void);
void Ins_RemoveInstitution (void);
void Ins_RenameInsShort (void);
void Ins_RenameInsFull (void);
void Ins_ChangeInsLogo (void);
void Ins_ChangeInsWWW (void);
void Ins_RecFormNewIns (void);

#endif
