// swad_lay.h: page layout

#ifndef _SWAD_LAY
#define _SWAD_LAY
/*
    SWAD ("Sistema Web de Apoyo a la Docencia" in Spanish,
    "Web System for Teaching Support" in English),
    is a web platform developed at the University of Granada (Spain),
    and used to support university teaching.
    Copyright (C) 1999-2010 Antonio Caas-Vargas
    & Daniel J. Calandria-Hernndez,
    University of Granada (SPAIN) (acanas@ugr.es)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/****************************************************************************/
/********************************* Headers **********************************/
/****************************************************************************/

/****************************************************************************/
/****************************** Public constants ****************************/
/****************************************************************************/

// Colors used in headers, backgrounds, etc.
#define WHITE			"FFFFFF"
#define YELLOW_BACKGROUND_MSG	"FFFDB9"
#define DARK_GRAY		"404040"
#define DARK_BLUE		"8CBCCE"
#define MEDIUM_BLUE		"AFD1DD"
#define LIGHT_BLUE		"C0DAE4"
#define VERY_LIGHT_BLUE		"DDECF1"
#define LIGHTEST_BLUE		"EAF3F6"
#define LIGHT_GREEN		"C0FF40"
#define LIGHTEST_GREEN		"F5FFD7"

#define Lay_MAX_BYTES_ALERT (16*1024)		// Max. size for alert message
// Important: the size of alert message must be enough large to store the longest messages.

#define Lay_MAX_BYTES_MSG_WINDOW_STATUS 1024	// Max. size for window status message

/****************************************************************************/
/******************************** Public types ******************************/
/****************************************************************************/

typedef enum
  {
   INFO    = 0,
   WARNING = 1,
   ERROR   = 2,
  } tMsgType;

/****************************************************************************/
/***************************** Public prototypes ****************************/
/****************************************************************************/

void Lay_WriteStartOfPage (void);
void Lay_WriteEndOfPage (void);
void Lay_WriteTitle (const char *Title);
void Lay_PutSendButton (const char *TextSendButton);
void Lay_PutSendAndUndoButtons (const char *TextSendButton);
void Lay_PutButtonCreate (void);
void Lay_StartTableFrame (const char *BorderColor,const char *BgColor,const char *Width);
void Lay_EndTableFrame (void);
void Lay_StartRoundFrameTable10 (const char *Corner,const char *Frame,const char *BgColor,const char *Width);
void Lay_EndRoundFrameTable10 (const char *Corner,const char *Frame);
void Lay_StartFrameRound4 (const char *Corner,const char *Frame,const char *BgColor,const char *Width,const char *Header);
void Lay_EndFrameRound4 (const char *Corner,const char *Frame);
void Lay_ShowErrorAndExit (const char *Message);
void Lay_ShowAlert (tMsgType MsgType,const char *Message);
void Lay_RefreshMsgsAndConnected (void);
void Lay_WritePageFooter (void);

void Lay_WriteHeaderClassPhoto (unsigned NumColumns,bool PrintView,bool DrawingClassPhoto,long InsCod,long DegCod,long CrsCod);
void Lay_WriteFootClassPhoto (void);

#endif
