// swad_lnk.h: institutional links

#ifndef _SWAD_LNK
#define _SWAD_LNK
/*
    SWAD ("Sistema Web de Apoyo a la Docencia" in Spanish,
    "Web System for Teaching Support" in English),
    is a web platform developed at the University of Granada (Spain),
    and used to support university teaching.
    Copyright (C) 1999-2010 Antonio Caas-Vargas
    & Daniel J. Calandria-Hernndez,
    University of Granada (SPAIN) (acanas@ugr.es)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/****************************************************************************/
/********************************* Headers **********************************/
/****************************************************************************/

/****************************************************************************/
/************************** Public types and constants **********************/
/****************************************************************************/

#define MAX_LENGTH_LINK_SHORT_NAME	 32
#define MAX_LENGTH_LINK_FULL_NAME	255

struct Link
  {
   long LnkCod;
   char ShortName[MAX_LENGTH_LINK_SHORT_NAME+1];
   char FullName[MAX_LENGTH_LINK_FULL_NAME+1];
   char WWW[Cte_MAX_LENGTH_WWW+1];
  };

/****************************************************************************/
/***************************** Public prototypes ****************************/
/****************************************************************************/

void Lnk_SeeLinks (void);
void Lnk_EditLinks (void);
void Lnk_GetListLinks (void);
void Lnk_FreeListLinks (void);
void Lnk_GetDataOfLinkByCod (struct Link *Plc);
long Lnk_GetParamLnkCod (void);
void Lnk_RemoveLink (void);
void Lnk_RenameLinkShort (void);
void Lnk_RenameLinkFull (void);
void Lnk_ChangeLinkWWW (void);
void Lnk_RecFormNewLink (void);
void Lnk_WriteMenuWithInstitutionalLinks (void);

#endif
