// swad_msg.h: messages between users

#ifndef _SWAD_MSG
#define _SWAD_MSG
/*
    SWAD ("Sistema Web de Apoyo a la Docencia" in Spanish,
    "Web System for Teaching Support" in English),
    is a web platform developed at the University of Granada (Spain),
    and used to support university teaching.
    Copyright (C) 1999-2010 Antonio Caas-Vargas
    & Daniel J. Calandria-Hernndez,
    University of Granada (SPAIN) (acanas@ugr.es)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/****************************************************************************/
/********************************* Headers **********************************/
/****************************************************************************/

#include "swad_sta.h"

/****************************************************************************/
/***************************** Public constants *****************************/
/****************************************************************************/

#define Msg_MAX_LENGTH_FILTER_CONTENT 80

/****************************************************************************/
/******************************* Public types *******************************/
/****************************************************************************/

typedef enum
  {
   Msg_MESSAGES_RECEIVED,
   Msg_MESSAGES_SENT,
  } Msg_TypeOfMessages_t;

typedef enum
  {
   Msg_STATUS_ALL,
   Msg_STATUS_DELETED,
   Msg_STATUS_NOTIFIED
  } Msg_Status_t;

/****************************************************************************/
/***************************** Public prototypes ****************************/
/****************************************************************************/

void Msg_ListEMails (void); // Creates an e-mail message to students

void Msg_FormMsgUsrs (void);
void Msg_WriteFormDNIOrNicksOtherRecipients (bool IsReply);
void Msg_WriteFormSubjectAndContentMsgToUsrs (void);
void Msg_RecMsgFromUsr (void);

void Msg_CreateFileNameMail (void);
void Msg_WriteWelcomeNoteEMail (struct UsrData *UsrDat);
void Msg_WriteFootNoteEMail (Txt_Language_t Language);

void Msg_WriteNumberOfNewMsgs (void);
void Msg_IncreaseNumNewMsgs (long UsrCod);
void Msg_ClearMyNumNewMsgs (void);
void Msg_ShowSntMsgs (void);
void Msg_ShowRecMsgs (void);
void Msg_ReqDelAllRecMsgs (void);
void Msg_ReqDelAllSntMsgs (void);
void Msg_DelAllRecMsgs (void);
void Msg_DelAllSntMsgs (void);
void Msg_GetParamMsgsCrsCod (void);
void Msg_GetParamFilterFromTo (void);
void Msg_GetParamFilterContent (void);
void Msg_MakeFilterFromToSubquery (char *FilterFromToSubquery);
void Msg_MakeFilterContentSubquery (char *FilterContentSubquery);
void Msg_DelSntMsg (void);
void Msg_DelRecMsg (void);
void Msg_ExpSntMsg (void);
void Msg_ExpRecMsg (void);

long Msg_InsertNewMsg (long CrsCod,long UsrCod,const char *Subject,const char *Txt);

void Msg_SetSentMsgAsDeleted (long MsgCod);
void Msg_DelAllRecOrSntMsgsUsr (Msg_TypeOfMessages_t TypeOfMessages,long UsrCod,
                                long FilterCrsCod,const char *FilterFromToSubquery,const char *FilterContentSubquery);
void Msg_SetReceivedMsgAsDeleted (long MsgCod,long UsrCod);

unsigned Msg_GetNumMsgsSentByTchsCrs (long CrsCod);
unsigned Msg_GetNumMsgsSent (Sta_LocationRange_t LocationRange,Msg_Status_t MsgStatus);
unsigned Msg_GetNumMsgsReceived (Sta_LocationRange_t LocationRange,Msg_Status_t MsgStatus);
void Msg_WriteNumMsgs (unsigned NumMsgs,unsigned NumUnreadMsgs,unsigned NumNewMsgs);
void Msg_ShowFormDelSentOrRecMsgs (Msg_TypeOfMessages_t TypeOfMessages,unsigned NumMsgs);
void Msg_PutHiddenParamsMsgsFilters (void);
void Msg_GetDistinctCoursesInMyMessages (Msg_TypeOfMessages_t TypeOfMessages);
void Msg_ShowFormSelectCourseSentOrRecMsgs (Msg_TypeOfMessages_t TypeOfMessages);
void Msg_ShowFormToFilterMsgs (Msg_TypeOfMessages_t TypeOfMessages);

void Msg_ShowAMessage (unsigned long MsgNum,long ThrCod,long MsgCod,Msg_TypeOfMessages_t TypeOfMessages,
                       bool LastMsg,char *LastSubject,bool NewMsg,bool ICanModerateForum);
void Msg_WriteMsgNumber (unsigned long MsgNum,bool NewMsg);
void Msg_WriteMsgAuthor (struct UsrData *UsrDat,unsigned WidthOfNameColumn,unsigned MaxCharsInName,const char *Style,const char *AnchorStyle,bool Enabled,const char *BgColor);
bool Msg_WriteCrsOrgMsg (long CrsCod);
void Msg_WriteListUsrsDstMsg (long MsgCod);
void Msg_WriteMsgDate (const char *DateTime,bool NewMsg);
void Msg_WriteMsgContent (char *Content,unsigned long MaxLength,bool InsertLinks,bool CambiarBRporRet);

void Msg_IndentDependingOnLevel (int Level,bool IsLastItemInLevel[]);

void Msg_WriteLinkToNetiquette (void);

#endif
