// swad_not.h: notices (yellow notes)

#ifndef _SWAD_NOT
#define _SWAD_NOT
/*
    SWAD ("Sistema Web de Apoyo a la Docencia" in Spanish,
    "Web System for Teaching Support" in English),
    is a web platform developed at the University of Granada (Spain),
    and used to support university teaching.
    Copyright (C) 1999-2010 Antonio Caas-Vargas
    & Daniel J. Calandria-Hernndez,
    University of Granada (SPAIN) (acanas@ugr.es)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/****************************************************************************/
/********************************* Headers **********************************/
/****************************************************************************/

#include "swad_sta.h"

/****************************************************************************/
/***************************** Public constants *****************************/
/****************************************************************************/

/****************************************************************************/
/******************************* Public types *******************************/
/****************************************************************************/

typedef enum
  {
   Not_LIST_NOTICES_TO_SEE,
   Not_LIST_NOTICES_TO_EDIT
  } Not_TypeNoticesListing_t;

#define Not_NUM_STATUS_NOTICE 3
typedef enum
  {
   Not_ACTIVE_NOTICE   = 0,
   Not_OBSOLETE_NOTICE = 1,
   Not_DELETED_NOTICE  = 2,
  } Not_NoticeStatus_t;	// Don't change these numbers because they are used in database

/****************************************************************************/
/***************************** Public prototypes ****************************/
/****************************************************************************/

void Not_ShowFormNotice (void);
void Not_ReceiveNotice (void);
void Not_ListNotices (void);
void Not_HideNotice (void);
void Not_ShowNotice (void);
void Not_DeleteNotice (void);
void Not_ShowNotices (Not_TypeNoticesListing_t TypeNoticesListing);
unsigned Not_GetNumNotices (Sta_LocationRange_t LocationRange,Not_NoticeStatus_t NoticeStatus,unsigned *NumNotif);

#endif
