// swad_ntf.h: notifications about events, sent by e-mail

#ifndef _SWAD_NTF
#define _SWAD_NTF
/*
    SWAD ("Sistema Web de Apoyo a la Docencia" in Spanish,
    "Web System for Teaching Support" in English),
    is a web platform developed at the University of Granada (Spain),
    and used to support university teaching.
    Copyright (C) 1999-2010 Antonio Caas-Vargas
    & Daniel J. Calandria-Hernndez,
    University of Granada (SPAIN) (acanas@ugr.es)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/****************************************************************************/
/********************************* Headers **********************************/
/****************************************************************************/

#include "swad_usr.h"

/****************************************************************************/
/***************************** Public constants *****************************/
/****************************************************************************/

#define Ntf_NUM_NOTIFY_EVENTS 5

/****************************************************************************/
/******************************* Public types *******************************/
/****************************************************************************/

typedef enum
  {
   Ntf_NEW_EXAM_ANNOUNCEMENT			= 0,
   Ntf_NEW_MARKS_FILE				= 1,
   Ntf_NEW_NOTICE				= 2,
   Ntf_NEW_MESSAGE				= 3,
   Ntf_NEW_RESPONSE_TO_MY_POSTS_IN_FORUMS	= 4,
  } Ntf_NotifyEvent_t;

/****************************************************************************/
/***************************** Public prototypes ****************************/
/****************************************************************************/

unsigned Ntf_StoreNotifyEventsToAllUsrs (Ntf_NotifyEvent_t NotifyEvent,long MsgCod,long ThrCod);
void Ntf_StoreNotifyEventToOneUser (Ntf_NotifyEvent_t NotifyEvent,struct UsrData *UsrDat,long MsgCod);
void Ntf_DeletePendingNotif (Ntf_NotifyEvent_t NotifyEvent,long MsgCod);
void Ntf_SendPendingNotifByEMailToAllUsrs (void);
void Ntf_ShowAlertNumUsrsToBeNotified (unsigned NumUsrsToBeNotified);
void Ntf_PutFormNotifyNewMsgs (void);
void Ntf_ChangeNotifyEvents (void);

#endif
