// swad_plg.h: plugins called from SWAD using web services

#ifndef _SWAD_PLG
#define _SWAD_PLG
/*
    SWAD ("Sistema Web de Apoyo a la Docencia" in Spanish,
    "Web System for Teaching Support" in English),
    is a web platform developed at the University of Granada (Spain),
    and used to support university teaching.
    Copyright (C) 1999-2010 Antonio Caas-Vargas
    & Daniel J. Calandria-Hernndez,
    University of Granada (SPAIN) (acanas@ugr.es)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/****************************************************************************/
/********************************* Headers **********************************/
/****************************************************************************/

/****************************************************************************/
/***************************** Public constants *****************************/
/****************************************************************************/

#define MAX_LENGTH_PLUGIN_NAME			255
#define MAX_LENGTH_PLUGIN_DESCRIPTION	       1023
#define MAX_LENGTH_PLUGIN_LOGO			 16

/****************************************************************************/
/******************************* Public types *******************************/
/****************************************************************************/

struct Plugin
  {
   long PlgCod;
   char Name[MAX_LENGTH_PLUGIN_NAME+1];
   char Description[MAX_LENGTH_PLUGIN_DESCRIPTION+1];
   char Logo[MAX_LENGTH_PLUGIN_LOGO+1];
   char URL[Cte_MAX_LENGTH_WWW+1];
   char IP[Cte_MAX_LENGTH_IP+1];
  };

/****************************************************************************/
/***************************** Public prototypes ****************************/
/****************************************************************************/

void Plg_ListPlugins (void);
void Plg_EditPlugins (void);
bool Plg_GetDataOfPluginByCod (struct Plugin *Plg);
void Plg_FreeListPlugins (void);
long Plg_GetParamPlgCod (void);
void Plg_RemovePlugin (void);
void Plg_RenamePlugin (void);
void Plg_ChangePlgDescription (void);
void Plg_ChangePlgLogo (void);
void Plg_ChangePlgURL (void);
void Plg_ChangePlgIP (void);
void Plg_RecFormNewPlg (void);
void Plg_WebService (void);

#endif
