#!/usr/bin/python
#
# swad_smtp.py: script called from SWAD to send e-mail
#
##########################################################################
#
#   SWAD ("Sistema Web de Apoyo a la Docencia" in Spanish,
#   "Web System for Teaching Support" in English),
#   is a web platform developed at the University of Granada (Spain),
#   and used to support university teaching.
#   Copyright (C) 1999-2010 Antonio Caas-Vargas
#   & Daniel J. Calandria-Hernndez,
#   University of Granada (SPAIN) (acanas@ugr.es)
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU Affero General Public License as
#   published by the Free Software Foundation, either version 3 of the
#   License, or (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Affero General Public License for more details.
#
#   You should have received a copy of the GNU Affero General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##########################################################################
#
#    This file has been programmed with the invaluable assistance of Antonio F. Daz-Garca.

import smtplib
import sys
import os.path

if len(sys.argv) < 5:
	# Error. Uso: swad_smtp dir_from dir_to asunto fichero_texto
	sys.exit(2)

fro = sys.argv[1]
to  = [sys.argv[2]]
sub = sys.argv[3]

if not os.path.exists(sys.argv[4]):
	# Error. El fichero "+ sys.argv[4]  + " no existe"
	sys.exit(3)

fich = open (sys.argv[4],'r')
texto = fich.read()
fich.close

msg = ("From: %s\r\nTo: %s\r\nSubject: %s\r\n\r\n"
       % (fro, ", ".join(to),sub))

msg = msg + texto
# print "Msg: " + msg

try:
	server = smtplib.SMTP('smtp.ugr.es')
	#server.set_debuglevel(1)
	server.sendmail(fro, to, msg)
	server.quit()
except:
	sys.exit(1)

