// swad_syl.h: syllabus

#ifndef _SWAD_SYL
#define _SWAD_SYL
/*
    SWAD ("Sistema Web de Apoyo a la Docencia" in Spanish,
    "Web System for Teaching Support" in English),
    is a web platform developed at the University of Granada (Spain),
    and used to support university teaching.
    Copyright (C) 1999-2010 Antonio Caas-Vargas
    & Daniel J. Calandria-Hernndez,
    University of Granada (SPAIN) (acanas@ugr.es)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/****************************************************************************/
/********************************* Headers **********************************/
/****************************************************************************/

/****************************************************************************/
/******************************* Public types *******************************/
/****************************************************************************/

typedef enum {Syl_SYLLABUS_LECTURES=0, Syl_SYLLABUS_PRACTICALS=1} Syl_SyllabusType_t;
typedef enum {SUBIR_POSICION, BAJAR_POSICION} ChangePosItemSyllabus_t;
typedef enum {INCREASE_LEVEL, DECREASE_LEVEL} ChangeLevelItemSyllabus_t;
// Structure used to get the limits (number of items) of the subtrees to exchange in a syllabus
struct MoveSubtrees
  {
   struct
     {
      int Ini,End;
     } ToGetUp,ToGetDown; // Number of items inicial y final de los dos subtrees a subir y a bajar
   bool MovAllowed;
  };

/****************************************************************************/
/***************************** Public prototypes ****************************/
/****************************************************************************/

void Syl_GetParamItemNumber (void);
void Syl_EditSyllabus (void);
void Syl_LoadSyllabusToMem (void);
void Syl_FreeListItemsSyllabus (void);
int  Syl_ReadLevelItemSyllabus (void);
void Syl_ShowSyllabus (void);
void Syl_ShowRowSyllabus (int NumItem,int Level,int *CodItem,const char *Text,bool NewItem);
void Syl_PutFormItemSyllabus (bool NewItem,int NumItem,int Level,int *CodItem,const char *Text,const char *Color);
void Syl_PutParamNumItem (int NumItem);
void Syl_WriteNumItem (char *StrDst,FILE *FileTgt,int NumItem,int Level,int *CodItem);
void Syl_RemoveItemSyllabus (void);
void Syl_UpItemSyllabus (void);
void Syl_DownItemSyllabus (void);
void Syl_ChangePlaceItemSyllabus (ChangePosItemSyllabus_t SubirOBajarPos);
void Syl_CalculateUpSubtreeSyllabus (struct MoveSubtrees *Subtree,int NumItem);
void Syl_CalculateDownSubtreeSyllabus (struct MoveSubtrees *Subtree,int NumItem);
void Syl_RightItemSyllabus (void);
void Syl_LeftItemSyllabus (void);
void Syl_ChangeLevelItemSyllabus (ChangeLevelItemSyllabus_t IncreaseOrDecreaseLevel);
void Syl_InsertItemSyllabus (void);
void Syl_ModifyItemSyllabus (void);
void Syl_BuildPathFileSyllabus (char *PathFile);
void Syl_OpenSyllabusFile (const char *PathDir,char *PathFile);
void Syl_WriteStartFileSyllabus (FILE *FileSyllabus);
void Syl_WriteAllItemsFileSyllabus (FILE *FileSyllabus);
void Syl_WriteItemFileSyllabus (FILE *FileSyllabus,int NumItem,const char *Text);
void Syl_WriteEndFileSyllabus (FILE *FileSyllabus);
void Syl_CloseFileSyllabus (void);
void Syl_WriteStartFileXML (FILE *FileTgt,const char *Type);
void Syl_WriteEndFileXML (FILE *FileTgt,const char *Type);

#endif
