// swad_tt.h: timetables

#ifndef _SWAD_TT
#define _SWAD_TT
/*
    SWAD ("Sistema Web de Apoyo a la Docencia" in Spanish,
    "Web System for Teaching Support" in English),
    is a web platform developed at the University of Granada (Spain),
    and used to support university teaching.
    Copyright (C) 1999-2010 Antonio Caas-Vargas
    & Daniel J. Calandria-Hernndez,
    University of Granada (SPAIN) (acanas@ugr.es)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/****************************************************************************/
/********************************* Headers **********************************/
/****************************************************************************/

#include "swad_boo.h"

/****************************************************************************/
/***************************** Public constants *****************************/
/****************************************************************************/

#define TT_MAX_BYTES_GROUP	255
#define TT_MAX_BYTES_PLACE	255

/****************************************************************************/
/******************************* Public types *******************************/
/****************************************************************************/

typedef enum
  {
   TT_COURSE_TIMETABLE,
   TT_MY_TIMETABLE,
   TT_TUTOR_TIMETABLE,
  } TT_TimeTableType_t;
typedef enum
  {
   TT_FREE_HOUR,
   TT_FIRST_HOUR,
   TT_NEXT_HOUR,
  } TT_HourType_t;
typedef enum
  {
   TT_NO_CLASS     = 0,
   TT_THEORY_CLASS = 1,
   TT_PRACT_CLASS  = 2,
   TT_TUTOR_CLASS  = 3,
  } TT_ClassType_t;

/****************************************************************************/
/***************************** Public prototypes ****************************/
/****************************************************************************/

void TT_ShowTimeTableGrpsSelected (void);
void TT_GetParamsTimeTable (void);
void TT_ShowClassTimeTable (void);
void TT_EditCrsTimeTable (void);
void TT_ShowTutTimeTable (void);
void TT_ShowMyTutTimeTable (void);
void TT_ShowTimeTable (TT_TimeTableType_t TimeTableType,long UsrCod);
void TT_WriteCrsTimeTableIntoDB (long CrsCod);
void TT_WriteTutTimeTableIntoDB (long UsrCod);
void TT_CreatTimeTableFromDB (TT_TimeTableType_t TimeTableType,long UsrCod);
void TT_ModifTimeTable (void);
void TT_DrawTimeTable (void);
void TT_TimeTableDrawAdjustRow (bool DrawSeparationBetweenDays);
void TT_TimeTableDrawDaysCells (void);
unsigned TT_TimeTableCalculateColsToDraw (unsigned Day,unsigned Hour);
void TT_DrawCellAlignTimeTable (void);
void TT_TimeTableDrawCell (unsigned Day,unsigned Hour,unsigned Column,unsigned ColSpan,
                           long CrsCod,TT_HourType_t HourType,TT_ClassType_t ClassType,int Duration,char *Group,long GrpCod,char *Place);

#endif
