// swad_txt.h: text messages on screen, in several languages

#ifndef _SWAD_TXT
#define _SWAD_TXT
/*
    SWAD ("Sistema Web de Apoyo a la Docencia" in Spanish,
    "Web System for Teaching Support" in English),
    is a web platform developed at the University of Granada (Spain),
    and used to support university teaching.
    Copyright (C) 1999-2010 Antonio Caas-Vargas
    & Daniel J. Calandria-Hernndez,
    University of Granada (SPAIN) (acanas@ugr.es)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Affero General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Affero General Public License for more details.

    You should have received a copy of the GNU Affero General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
/****************************************************************************/
/********************************* Headers **********************************/
/****************************************************************************/

/****************************************************************************/
/***************************** Public constants *****************************/
/****************************************************************************/

#define Txt_NUM_LANGUAGES 6

/****************************************************************************/
/******************************* Public types *******************************/
/****************************************************************************/

typedef enum
  {
   Txt_LANGUAGE_DE = 0,
   Txt_LANGUAGE_EN = 1,
   Txt_LANGUAGE_ES = 2,
   Txt_LANGUAGE_FR = 3,
   Txt_LANGUAGE_IT = 4,
   Txt_LANGUAGE_PT = 5,
  } Txt_Language_t; // ISO 639-1 language codes
#define Txt_LANGUAGE_DEFAULT Txt_LANGUAGE_ES

/****************************************************************************/
/***************************** Public prototypes ****************************/
/****************************************************************************/

#endif
